<%@ include file="includes/jspheader.jsp" %>
<%@ include file="includes/jspencoding.jsp" %>
<%@ include file="includes/sdkinit.jsp" %>
<%@ include file="includes/sdkadmincheck.jsp" %>

<%@ page import="com.esko.webcenter.src.root.*"%>
<%@ page import="java.util.*" %>
<%@ page import="sun.misc.BASE64Decoder" %>
<%@ page import="java.util.logging.*" %><%@ page import="com.esko.webcenter.log.*" %>
<%@ page import="com.esko.webcenter.src.util.*" %>
<%
	// === Start of the main scriplet ===

	// action parameter constants
	final String ACTION_CREATE = "create";
	final String ACTION_MODIFY = "modify";

	String loginID = LoginMgr.getLoginMgr(session).getLoginID(); 
	String userID = LoginMgr.getLoginMgr(session).getLoginUserID();

	// get parameters
	Properties requestParams = SDKUtils.getRequestParams(request, session, application, requestParamsLoginCheck);

	// determine if the data is passed in form of parameters or attributes (from usermgrusersfromfile.jsp)
	// (note "usersfilename" has to be all lowercase, because of RequestUtils.normalizeRequestParams() function)
	boolean asAttr = requestParams.isEmpty() || requestParams.containsKey("usersfilename");

	if (asAttr) {
		requestParams = RequestUtils.normalizeRequestAttrs(request);
	}

	String action = (requestParams.containsKey("action")) ? ((String[])requestParams.get("action"))[0] : null;
	String modUserID = (requestParams.containsKey("userid")) ? ((String[])requestParams.get("userid"))[0] : "";
	String newUserName = (requestParams.containsKey("newusername")) ? ((String[])requestParams.get("newusername"))[0] : "";
	String newPassword = (requestParams.containsKey("newuserpassword")) ? ((String[])requestParams.get("newuserpassword"))[0] : "";
	String companyShortName = (requestParams.containsKey("newusercompanycode")) ? ((String[])requestParams.get("newusercompanycode"))[0] : "";
	String companyName = (requestParams.containsKey("newusercompanyname")) ? ((String[])requestParams.get("newusercompanyname"))[0] : "";
	String locationName = (requestParams.containsKey("newusercompanylocation")) ? ((String[])requestParams.get("newusercompanylocation"))[0] : "";
	String lastName = (requestParams.containsKey("newuserlastname")) ? ((String[])requestParams.get("newuserlastname"))[0] : "";
	String firstName = (requestParams.containsKey("newuserfirstname")) ? ((String[])requestParams.get("newuserfirstname"))[0] : "";
	String isProjectMgr = (requestParams.containsKey("newuserisprojectmanager")) ? ((String[])requestParams.get("newuserisprojectmanager"))[0] : "";
	String email = (requestParams.containsKey("newuseremail")) ? ((String[])requestParams.get("newuseremail"))[0] : "";
	String phoneNumber = (requestParams.containsKey("newuserphone")) ? ((String[])requestParams.get("newuserphone"))[0] : "";
	String mobileNumber = (requestParams.containsKey("newusermobile")) ? ((String[])requestParams.get("newusermobile"))[0] : "";
	String userFunction = (requestParams.containsKey("newuserfunction")) ? ((String[])requestParams.get("newuserfunction"))[0] : "";
	String forcePswdChange = (requestParams.containsKey("newuserforcepasswordchange")) ? ((String[])requestParams.get("newuserforcepasswordchange"))[0] : "";
	String guaranteedAccess = (requestParams.containsKey("newuserguaranteedaccess")) ? ((String[])requestParams.get("newuserguaranteedaccess"))[0] : "";
	String maxSessions = (requestParams.containsKey("newusernrofsessions")) ? ((String[])requestParams.get("newusernrofsessions"))[0] : "";
	
	// process loaded parameters/attributes
	// ------------------------------------
	if ((newUserName.length() == 0) && (modUserID.length() == 0)) {
		// mandatory attributes check
		out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING, "Either 'newusername' or 'userid' parameter has to be specified."));
		checkLogOff(session);
		return;
	}
	else if (newUserName.equalsIgnoreCase(User.ADMIN) || modUserID.equals(User.ADMIN_ID)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_ADMIN_USER_EXCPT));
		checkLogOff(session);
		return;
	}
	else if (newUserName.equalsIgnoreCase(User.CADX) || modUserID.equals(User.CADX_ID)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_ADMIN_USER_EXCPT));
		checkLogOff(session);
		return;
	}
	else if (newUserName.equalsIgnoreCase(User.CLEANUP) || modUserID.equals(User.CLEANUP_ID)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_ADMIN_USER_EXCPT));
		checkLogOff(session);
		return;
	}
	else if (newUserName.equalsIgnoreCase(User.WORKFLOW) || modUserID.equals(User.WORKFLOW_ID)) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_ADMIN_USER_EXCPT));
		checkLogOff(session);
		return;
	}

	// remember whether the company short name was specified
	boolean shortNameSpecified = (companyShortName.length() > 0);
	// if only one of the company name and short name (code) was specified, fill the second one with 
	// the same value (none of them can be empty)
	if (companyName.length() == 0) companyName = companyShortName;
	else if (companyShortName.length() == 0) companyShortName = companyName;

	// user company name and location has to be verified to suppress not allowed combinations
	if (((companyShortName.length() == 0) && (locationName.length() > 0)) 
			|| ((companyShortName.length() > 0) && (locationName.length() == 0))) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_COMP_LOC_BOND));
		checkLogOff(session);
		return;
	}

	// process action parameter
	if (action != null)
	{
		action = action.trim();
		if (!action.equalsIgnoreCase(ACTION_CREATE) && !action.equalsIgnoreCase(ACTION_MODIFY))
		{
			out.write(SDKUtils.ShowError(SDKUtils.SDK_WRONG_PARAM, "Valid values for 'action' parameter are: 'create', 'modify'."));
			checkLogOff(session);
			return;
		}
	}
	else action = "";

	// create a new user and fills his/her attributes
	User newUser = null;
	UserTM userTM = null;
	
	// check if user + company combination already exists in database
	// if so preload the user in order to be able to change only named attributes (update the user)
	// create the EJB 
	userTM = DBTMUtils.findBean(response, session, UserTM.class);
	if (userTM == null) {
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
		checkLogOff(session);
		return;
	}

	if (modUserID.length() > 0) {
		try {
			// ID of user to be modified was specified - use it
			newUser = userTM.findById(loginID, modUserID);
		}
		catch (WebCenterRemoteException ejbEx) {
			LogMgr.getLogger().log(Level.SEVERE, "Error: UserTMBean.findById() Details: " + ejbEx.toString());
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
			checkLogOff(session);
			return;
		}
	} 
	else {
		try {
			// new user or existing user to be found by name and optionally by short company name
			newUser = userTM.findUserByCompanyNameAndUserName(loginID, companyShortName, newUserName);
		}	
		catch (WebCenterRemoteException ejbEx) {
			LogMgr.getLogger().log(Level.SEVERE, "Error: UserTMBean.findUserByCompanyNameAndUserName() Details: " + ejbEx.toString());
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
			checkLogOff(session);
			return;
		}
	}
	
	if ((newUser == null) || newUser.isDeleted() || !newUser.isLoaded())
	{
		// specified new user doesn't exist in WCR database or is deleted
		if (action.equalsIgnoreCase(ACTION_MODIFY) || (modUserID.length() > 0))
		{
			// when explicitely set to modify existing WCR user, return error
			out.write(SDKUtils.ShowError(SDKUtils.SDK_NO_USER));
			checkLogOff(session);
			return;
		}
		if (lastName.length() == 0)
		{
			// when creating a new user, newuserlastname parameter is also mandatory...
			out.write(SDKUtils.ShowError(SDKUtils.SDK_PARAM_MISSING, "newuserlastname parameter must be also specified when creating a new user."));
			checkLogOff(session);
			return;
		}
		newUser = new User();
	
		// ensure we get a random user key, when a new user is stored in UserDB
		newUser.setUserKey(User.RANDOM_USERKEY_PLACEHOLDER);
	}
	else
	{
		// specified new user already exists in WCR database
		if (action.equalsIgnoreCase(ACTION_CREATE))
		{
			// when explicitely set to create a new WCR user, return error
			out.write(SDKUtils.ShowError(SDKUtils.SDK_USER_EXISTS));
			checkLogOff(session);
			return;
		}
	}

	// check if company already exists in database (note the companyName needn't to be checked as the 
	// companyShortName is always filled if at least one of them is specified by the caller)
	if (companyShortName.length() > 0) {
		CompanyTM companyTM = DBTMUtils.findBean(response, session, CompanyTM.class);
		Company company = new Company();
		LocationTM locationTM = DBTMUtils.findBean(response, session, LocationTM.class);
		Location location = new Location();
		Vector locationList = new Vector();
		if ((companyTM == null) || (locationTM == null)) {
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
			checkLogOff(session);
			return;
		}
		try {
			if (shortNameSpecified) {
				company = companyTM.findByName(loginID, companyShortName);
			} else {
				company = companyTM.findByLegalName(loginID, companyName);
			}
		}
		catch (WebCenterRemoteException ejbEx) 	{
			LogMgr.getLogger().log(Level.SEVERE, "Error: companyTM.findByName Details: " + ejbEx.toString());
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
			checkLogOff(session);
			return;
		}
		if ((company == null) || !company.isLoaded()) {
			// create new company (refered by user) and fills its attributes
			company = new Company();   // for safety
			company.setName(companyShortName);
			company.setLegalName(companyName);
		}
		else {
			try {
				// get the location list of given company
				locationList = companyTM.loadLocations(loginID, company.getObjectID());
			}
			catch (WebCenterRemoteException ejbEx) 	{
				LogMgr.getLogger().log(Level.SEVERE, "Error: locationTM.findById Details: " + ejbEx.toString());
				out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
				checkLogOff(session);
				return;
			}
		}
		// check if location of company already exists - if not create one
		try {
		  location = locationTM.findByNameAndCompany(loginID, locationName, company.getObjectID());
		}
		catch (WebCenterRemoteException  ejbEx) 	{
			DBTMUtils.processRemoteException(response, session, ejbEx, "locationTM.findByNameAndCompany");
			LogMgr.getLogger().log(Level.SEVERE, "Error: locationTM.findByNameAndCompany Details: " + ejbEx.toString());
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
			checkLogOff(session);
			return;
		}
		if ((location == null) || !location.isLoaded()) {
			// create new location (refered by company of created user) and fills its attributes (name is enough)
			location = new Location();   // for safety
			location.setName(locationName);
			locationList.add(location);
			company.setLocationList(locationList);
		}
		if (!company.isLoaded() || !location.isLoaded()) {
			// save the new company into database
		  try {
				company = companyTM.save(loginID, company);
			}
			catch (WebCenterRemoteException ejbEx) 	{
				LogMgr.getLogger().log(Level.SEVERE, "Error: companyTM.save Details: " + ejbEx.toString());
				out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
				checkLogOff(session);
				return;
			}
//			System.out.println("Company " + companyName + " was created due to reference in newly created user " + newUserName + ".");   //JANH then DEL!!!

			// reload the location to get valid location ID
			try {
			  location = locationTM.findByNameAndCompany(loginID, locationName, company.getObjectID());
			}
			catch (WebCenterRemoteException  ejbEx) 	{
				DBTMUtils.processRemoteException(response, session, ejbEx, "locationTM.findByNameAndCompany");
				LogMgr.getLogger().log(Level.SEVERE, "Error: locationTM.findByNameAndCompany Details: " + ejbEx.toString());
				out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
				checkLogOff(session);
				return;
			}
		}
		if ((location == null) || !location.isLoaded()) {
			LogMgr.getLogger().log(Level.SEVERE, "Error: Problem with location save");
			out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
			checkLogOff(session);
			return;
		}
		newUser.setLocationID(location.getObjectID());
	}
	else {
		// location without a company cannot be saved to database
		
		//JANH it gets here only if company and location are blank. In this case the original values should be held.
		// This way it's not possible to "unassign" company from a user that already has one...
		// ...Solution could be to add parameter that would switch between "insert" and "replace" modes (for all params.).
//		newUser.setLocationID("");
	}

	// save remaining attributes into the instance of User class
	// when editing user, there are cases you don't want to change username - no new username is supplied
	if (newUserName.length() > 0)
		newUser.setName(newUserName);
	
	//30.8.2007 JAMI > store password, but first Base64 Decode it
	if (newPassword.length() > 0)  {
		if (asAttr) {
			newUser.setPassword(newPassword);
		}
		else
		{
			//decode the password using Base64
			BASE64Decoder decoder = new BASE64Decoder();
			byte[] decodedStr = decoder.decodeBuffer(newPassword);
			String decodedPswd = new String(decodedStr);
			//now store it
			newUser.setPassword(decodedPswd);
		}
	}
	
	if (asAttr) {
		newUser.setPasswordForcedExpired(false);   // to be more convenient for testing (not in WCR6.2)
	}
	else {
		newUser.setPasswordForcedExpired(forcePswdChange.equalsIgnoreCase("1"));
	}
	if (lastName.length() > 0) newUser.setLastName(lastName);
	if (firstName.length() > 0) newUser.setFirstName(firstName);
  if (isProjectMgr.length() > 0) {
  	// load role list prior to its modification
		if (newUser.getObjectID()!=null && newUser.getObjectID().length()>0 ) 
  		{
			Vector roles = userTM.loadRolesList(loginID, newUser.getObjectID(), newUser.getOwnerID());
			newUser.setRoleList(roles);
		}
		if (isProjectMgr.equalsIgnoreCase("1")) 
			newUser.addRoleIntoList(RoleDefinition.PROJECT_MANAGER_ID);
	  	else 
	  		newUser.removeRoleFromList(RoleDefinition.PROJECT_MANAGER_ID);
  }
	if (email.length() > 0) newUser.setEmail(email);
	if (phoneNumber.length() > 0) newUser.setPhoneNumber(phoneNumber);
	if (mobileNumber.length() > 0) newUser.setMobileNumber(mobileNumber);
	if (userFunction.length() > 0) newUser.setFunction(userFunction);
	if (guaranteedAccess.length() > 0) newUser.setGuaranteedAccessValue(guaranteedAccess.equalsIgnoreCase("1"));
	
	// set max number of sessions
	if (maxSessions.length() > 0){
		newUser.setMaxSessions(maxSessions);
	} else if (action.equalsIgnoreCase(ACTION_CREATE)){
		newUser.setMaxSessions(User.MAX_SESSION_DEFAULT);
	}
	
	if (newUser.getOwnerID() == null) newUser.setOwnerID(userID);

	// save the user into database
	if (newUser != null) {
		  try {
				newUser = userTM.save(loginID, newUser);
			}
			catch (WebCenterRemoteException ejbEx) 	{
				LogMgr.getLogger().log(Level.SEVERE, "Error: UserTM.save Details: " + ejbEx.toString());
				out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR, ejbEx));
				checkLogOff(session);
				return;
			}
	}
	
	// Reload the user from the DB so the password in the User object is encrypted
	newUser = userTM.findById(loginID, newUser.getObjectID());
	if (newUser == null) {
		LogMgr.getLogger().log(Level.SEVERE, "Error: Unable to find user by ID. Details: " + newUser.getObjectID());
		out.write(SDKUtils.ShowError(SDKUtils.SDK_UNDEF_ERROR));
		checkLogOff(session);
  	return;
  }
	
	request.setAttribute("wasUserCreated","1");   // needed for proper function of usermgrusersfromfile.jsp
	
	// output of the SDK call
	out.write("<userID>" + newUser.getObjectID() + "</userID>");
	
	checkLogOff(session);
  System.out.println("User " + newUser.getObjectID() + " added/updated!");   //JANH then DEL !!!

%>
